%define _prefix /usr/local/scotch/%{version}
%define _mandir %{_prefix}/man
%define modulefile_dir /usr/local/share/Modules/modulefiles/scotch
%global openmpidir %{_builddir}/ptscotch-openmpi-%{version}-%{release}
%define modulefile_diropenmpi /usr/local/share/Modules/modulefiles/scotch/openmpi-%{openmpiv}
%global mpichdir %{_builddir}/ptscotch-mpich-%{version}-%{release}
%define modulefile_dirmpich /usr/local/share/Modules/modulefiles/scotch/mpich
%global impidir %{_builddir}/ptscotch-impi-%{version}-%{release}
%define modulefile_dirimpi /usr/local/share/Modules/modulefiles/scotch/impi
%define _prefixopenmpi /usr/local/scotch/openmpi-%{openmpiv}/%{version}
%define _prefixmpich /usr/local/scotch/mpich/%{version}
%define _prefiximpi /usr/local/scotch/impi/%{version}

# our additions
%bcond_without openmpi
%bcond_without impi
%bcond_with mpich
# openmpi specific settings
%{!?openmpiv: %global openmpiv 1.6.5}
%define nopenmpiv  %( printf "%02d%02d%02d" `echo %{openmpiv} | cut -d. -f1,2,3 --output-delimiter=" "` )
%define _openmpi_load module load openmpi
%define _openmpi_unload module unload openmpi
%define impiv 2017.2
%define nimpiv %( echo %{impiv} | tr -d . )
%define _impi_load module load intel-mpi/gcc
%define _impi_unload module unload intel-mpi/gcc

# Shared library versioning:
# Increment if interface is changed in an incompatible way
%global so_maj 0
# Increment if interface is extended
%global so_min 2

Version:       6.0.4
%define nversion %(echo %{version} | tr -d .)
Name:          scotch%{nversion}
%define rname  scotch
Summary:       Graph, mesh and hypergraph partitioning library
Release:       13%{?dist}

License:       CeCILL-C
URL:           https://gforge.inria.fr/projects/scotch/
Source0:       https://gforge.inria.fr/frs/download.php/file/34078/%{rname}_%{version}.tar.gz
Source1:       scotch-Makefile.shared.inc.in

# Makefile fixes for building esmumps
Patch0:        scotch_esmumps.patch

BuildRequires: flex
BuildRequires: bison
BuildRequires: zlib-devel
BuildRequires: bzip2-devel
#if 0%{?fedora}
BuildRequires:  lzma-devel
#endif

%description
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering. The parallel scotch libraries are packaged in the
ptscotch sub-packages.

%package devel
Summary:       Development libraries for scotch
Requires:      %{name}%{?_isa} = %{version}-%{release}
Obsoletes:     %{name}-static < 6.0.0-8

%description devel
This package contains development libraries for scotch.


%package doc
Summary:       Documentations and example for scotch and ptscotch
BuildArch:     noarch

%description doc
Contains documentations and example for scotch and ptscotch

###############################################################################
%if %{with mpich}
%package -n pt%{name}-mpich
Summary:       PT-Scotch libraries compiled against mpich
BuildRequires: mpich-devel

%description -n pt%{name}-mpich
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering. This sub-package provides parallelized scotch libraries
compiled with mpich.


%package -n pt%{name}-mpich-devel
Summary:       Development libraries for PT-Scotch (mpich)
Requires:      pt%{name}-mpich%{?_isa} = %{version}-%{release}
Obsoletes:     pt%{name}-mpich-static < 6.0.0-8

%description -n pt%{name}-mpich-devel
This package contains development libraries for PT-Scotch, compiled against
mpich.

%package -n pt%{name}-mpich-devel-parmetis
Summary:       Parmetis compatibility header for scotch
Requires:      pt%{name}-mpich-devel%{?_isa} = %{version}-%{release}

%description -n pt%{name}-mpich-devel-parmetis
This package contains the parmetis compatibility header for scotch.

%endif
###############################################################################

%if %{with openmpi}
%package -n pt%{name}-openmpi%{nopenmpiv}
Summary:       PT-Scotch libraries compiled against openmpi %{openmpiv}
BuildRequires: openmpi%{nopenmpiv}-gcc-devel

%description -n pt%{name}-openmpi%{nopenmpiv}
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering. This sub-package provides parallelized scotch libraries
compiled with openmpi.


%package -n pt%{name}-openmpi%{nopenmpiv}-devel
Summary:       Development libraries for PT-Scotch (openmpi) %{openmpiv}
Requires:      pt%{name}-openmpi%{nopenmpiv}%{?_isa} = %{version}-%{release}
Obsoletes:     pt%{name}-openmpi%{nopenmpiv}-static < 6.0.0-8

%description -n pt%{name}-openmpi%{nopenmpiv}-devel
This package contains development libraries for PT-Scotch, compiled against openmpi.


%package -n pt%{name}-openmpi%{nopenmpiv}-devel-parmetis
Summary:       Parmetis compatibility header for scotch
Requires:      pt%{name}-openmpi%{nopenmpiv}-devel%{?_isa} = %{version}-%{release}

%description -n pt%{name}-openmpi%{nopenmpiv}-devel-parmetis
This package contains the parmetis compatibility header for scotch.
%endif
###############################################################################
%if %{with impi}
%package -n pt%{name}-impi
Summary:       PT-Scotch libraries compiled against intel-mpi
BuildRequires: intel-mpi%{nimpiv}-modules-devel intel-mpi%{nimpiv}-modules-gcc

%description -n pt%{name}-impi
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering. This sub-package provides parallelized scotch libraries
compiled with intel-mpi.


%package -n pt%{name}-impi-devel
Summary:       Development libraries for PT-Scotch (intel-mpi)
Requires:      pt%{name}-impi%{?_isa} = %{version}-%{release}
Obsoletes:     pt%{name}-impi-static < 6.0.0-8

%description -n pt%{name}-impi-devel
This package contains development libraries for PT-Scotch, compiled against
intel-mpi.

%package -n pt%{name}-impi-devel-parmetis
Summary:       Parmetis compatibility header for scotch
Requires:      pt%{name}-impi-devel%{?_isa} = %{version}-%{release}

%description -n pt%{name}-impi-devel-parmetis
This package contains the parmetis compatibility header for scotch.

%endif
###############################################################################

%prep
%setup -q -n scotch_%{version}
%patch0 -p1

cp -a %{SOURCE1} src/Makefile.inc

# Convert the license files to utf8
for file in doc/CeCILL-C_V1-en.txt doc/CeCILL-C_V1-fr.txt; do
    iconv -f iso8859-1 -t utf-8 $file > $file.conv && mv -f $file.conv $file
done

# No lzma-devel in el
#if 0%{?rhel}
#sed -i -e s/-llzmadec// -e s/-DCOMMON_FILE_COMPRESS_LZMA// src/Makefile.inc
#endif

cp -a . %{openmpidir}
cp -a . %{mpichdir}
cp -a . %{impidir}


%build
pushd src/
%make_build scotch esmumps CFLAGS="%{optflags}" LDFLAGS="%{?__global_ldflags}" SOMAJ="%{so_maj}"
popd

%if %{with mpich}
%{_mpich_load}
pushd %{mpichdir}/src/
%make_build ptscotch ptesmumps CFLAGS="%{optflags}" LDFLAGS="%{?__global_ldflags}" SOMAJ="%{so_maj}"
popd
%{_mpich_unload}
%endif

%if %{with openmpi}
%{_openmpi_load}
pushd %{openmpidir}/src/
%make_build ptscotch ptesmumps CFLAGS="%{optflags}" LDFLAGS="%{?__global_ldflags}" SOMAJ="%{so_maj}"
popd
%{_openmpi_unload}
%endif

%if %{with impi}
%{_impi_load}
pushd %{impidir}/src/
%make_build ptscotch ptesmumps CFLAGS="%{optflags}" LDFLAGS="%{?__global_ldflags}" SOMAJ="%{so_maj}"
popd
%{_impi_unload}
%endif

%install
%define doinstall() \
make install prefix=%{buildroot}${MPI_HOME} libdir=%{buildroot}${MPI_LIB} includedir=%{buildroot}${MPI_INCLUDE} mandir=%{buildroot}${MPI_MAN} bindir=%{buildroot}${MPI_BIN} \
# Fix debuginfo packages not finding sources (See libscotch/Makefile) \
ln -s parser_ll.c libscotch/lex.yy.c \
ln -s parser_yy.c libscotch/y.tab.c \
ln -s parser_ly.h libscotch/y.tab.h \
\
pushd %{buildroot}${MPI_LIB}; \
for lib in *.so; do \
    chmod 755 $lib \
    mv $lib $lib.%{so_maj}.%{so_min} && ln -s $lib.%{so_maj}.%{so_min} $lib && ln -s $lib.%{so_maj}.%{so_min} $lib.%{so_maj} \
done \
popd \
\
pushd %{buildroot}${MPI_BIN} \
for prog in *; do \
    mv $prog scotch_${prog} \
    chmod 755 scotch_$prog \
done \
popd \
\
pushd %{buildroot}${MPI_MAN}/man1/ \
for man in *; do \
    mv ${man} scotch_${man} \
done \
# Cleanup man pages (some pages are only relevant for ptscotch packages, and vice versa) \
for man in *; do \
  if [ ! -f %{buildroot}${MPI_BIN}/${man/.1/} ]; then \
    rm -f $man \
  fi \
done \
popd

function createmodule() {
D=$1
P=$MPI_HOME
shift
mkdir -p %{buildroot}$D
cat <<ENDMODULE > %{buildroot}$D/%{version}
#%Module
# NOTE: This is an automatically-generated file!  (generated by the
# scotch rpm).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds $@ to various paths"
}

module-whatis   "Sets up $@ in your environment"

prepend-path PATH "$P/bin"
prepend-path LD_LIBRARY_PATH "$P/%{_lib}"
prepend-path LIBRARY_PATH "$P/%{_lib}"
prepend-path MANPATH "$P/share/man"
setenv SCOTCHDIR "$P"
append-path -d { } LDFLAGS "-L$P/%{_lib}"
append-path -d { } INCLUDE "-I$P/include"
append-path CPATH "$P/include"
append-path -d { } FFLAGS "-I$P/include"
append-path -d { } LOCAL_LDFLAGS "-L$P/%{_lib}"
append-path -d { } LOCAL_INCLUDE "-I$P/include"
append-path -d { } LOCAL_CFLAGS "-I$P/include"
append-path -d { } LOCAL_FFLAGS "-I$P/include"
append-path -d { } LOCAL_CXXFLAGS "-I$P/include"
ENDMODULE
}

###############################################################################

export MPI_HOME=%{_prefix}
export MPI_LIB=%{_libdir}
export MPI_INCLUDE=%{_includedir}
export MPI_MAN=%{_mandir}
export MPI_BIN=%{_bindir}
pushd src
%doinstall
createmodule %{modulefile_dir} scotch %{version}
popd

###############################################################################
%if %{with mpich}
%{_mpich_load}
pushd %{mpichdir}/src
%doinstall
createmodule %{modulefile_dirmpich} ptscotch %{version} built with mpich
install -m644 libscotchmetis/parmetis.h %{buildroot}${MPI_INCLUDE}
popd
%{_mpich_unload}
%endif
###############################################################################

%if %{with openmpi}
%{_openmpi_load}
export MPI_HOME=%{_prefixopenmpi}
export MPI_LIB=$MPI_HOME/lib64
export MPI_INCLUDE=$MPI_HOME/include
export MPI_MAN=$MPI_HOME/share/man
export MPI_BIN=$MPI_HOME/bin
pushd %{openmpidir}/src
%doinstall
createmodule %{modulefile_diropenmpi} ptscotch %{version} built with openmpi-%{openmpiv}
install -m644 libscotchmetis/parmetis.h %{buildroot}${MPI_INCLUDE}
popd
%{_openmpi_unload}
%endif
###############################################################################

%if %{with impi}
%{_impi_load}
export MPI_HOME=%{_prefiximpi}
export MPI_LIB=$MPI_HOME/lib64
export MPI_INCLUDE=$MPI_HOME/include
export MPI_MAN=$MPI_HOME/share/man
export MPI_BIN=$MPI_HOME/bin
pushd %{impidir}/src
%doinstall
createmodule %{modulefile_dirimpi} ptscotch %{version} built with intel-mpi
install -m644 libscotchmetis/parmetis.h %{buildroot}${MPI_INCLUDE}
popd
%{_impi_unload}
%endif
###############################################################################

%if 0
%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post -n ptscotch-mpich -p /sbin/ldconfig

%postun -n ptscotch-mpich -p /sbin/ldconfig

%post -n ptscotch-openmpi -p /sbin/ldconfig

%postun -n ptscotch-openmpi -p /sbin/ldconfig
%endif

%{!?_licensedir:%global license %%doc}
%files
%license doc/CeCILL-C_V1-en.txt
%dir %{_prefix}
%dir %{_bindir}
%dir %{_libdir}
%dir %{_mandir}
%dir %{_mandir}/man1
%{_bindir}/*
%{_libdir}/libscotch*.so.*
%{_libdir}/libesmumps*.so.*
%{_mandir}/man1/*
%dir %{modulefile_dir}
%{modulefile_dir}/%{version}

%files devel
%dir %{_includedir}
%{_libdir}/libscotch*.so
%{_libdir}/libesmumps*.so
%{_includedir}/*scotch*.h
%{_includedir}/*esmumps*.h

%if %{with mpich}
%files -n pt%{name}-mpich
%license doc/CeCILL-C_V1-en.txt
%{_libdir}/mpich/lib/lib*scotch*.so.*
%{_libdir}/mpich/lib/lib*esmumps*.so.*
%{_libdir}/mpich/bin/*
%{_mandir}/mpich*/*
%{modulefile_dirmpich}

%files -n pt%{name}-mpich-devel
%{_includedir}/mpich*/*scotch*.h
%{_includedir}/mpich*/*esmumps*.h
%{_libdir}/mpich/lib/lib*scotch*.so
%{_libdir}/mpich/lib/lib*esmumps*.so

%files -n pt%{name}-mpich-devel-parmetis
%{_includedir}/mpich*/parmetis.h
%endif

%if %{with openmpi}
%files -n pt%{name}-openmpi%{nopenmpiv}
%license doc/CeCILL-C_V1-en.txt
%dir %{_prefixopenmpi}
%dir %{_prefixopenmpi}/bin
%dir %{_prefixopenmpi}/lib64
%dir %{_prefixopenmpi}/share
%{_prefixopenmpi}/lib64/lib*scotch*.so.*
%{_prefixopenmpi}/lib64/lib*esmumps*.so.*
%{_prefixopenmpi}/bin/*
%{_prefixopenmpi}/share/man
%{modulefile_diropenmpi}

%files -n pt%{name}-openmpi%{nopenmpiv}-devel
%dir %{_prefixopenmpi}/include
%{_prefixopenmpi}/include/*scotch*.h
%{_prefixopenmpi}/include/*esmumps*.h
%{_prefixopenmpi}/lib64/lib*scotch*.so
%{_prefixopenmpi}/lib64/lib*esmumps*.so

%files -n pt%{name}-openmpi%{nopenmpiv}-devel-parmetis
%{_prefixopenmpi}/include/parmetis.h
%endif

%if %{with impi}
%files -n pt%{name}-impi
%license doc/CeCILL-C_V1-en.txt
%dir %{_prefiximpi}
%dir %{_prefiximpi}/bin
%dir %{_prefiximpi}/lib64
%dir %{_prefiximpi}/share
%{_prefiximpi}/lib64/lib*scotch*.so.*
%{_prefiximpi}/lib64/lib*esmumps*.so.*
%{_prefiximpi}/bin/*
%{_prefiximpi}/share/man
%{modulefile_dirimpi}

%files -n pt%{name}-impi-devel
%dir %{_prefiximpi}/include
%{_prefiximpi}/include/*scotch*.h
%{_prefiximpi}/include/*esmumps*.h
%{_prefiximpi}/lib64/lib*scotch*.so
%{_prefiximpi}/lib64/lib*esmumps*.so

%files -n pt%{name}-impi-devel-parmetis
%{_prefiximpi}/include/parmetis.h
%endif

%files doc
%license doc/CeCILL-C_V1-en.txt
%doc doc/*.pdf
%doc doc/scotch_example.f

%changelog
* Thu Oct 27 2016 Sandro Mani <manisandro@gmail.com> - 6.0.4-13
- Drop -DSCOTCH_PTHREAD (#1386707)

* Mon Oct 24 2016 Dan Horák <dan[at]danny.cz> - 6.0.4-12
- drop ExcludeArch

* Fri Oct 21 2016 Orion Poplawski <orion@cora.nwra.com> - 6.0.4-11
- Rebuild for openmpi 2.0

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 6.0.4-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jan 22 2016 Sandro Mani <manisandro@gmail.com> - 6.0.4-9
- Install parmetis.h in separate package

* Tue Dec 01 2015 Than Ngo <than@redhat.com> - 6.0.4-8
- ExcludeArch: s390 s390x

* Thu Nov 26 2015 Dave Love <loveshack@fedoraproject.org> - 6.0.4-7
- Install parmetis.h
- Conditionalize %%license and %%__global_ldflags

* Tue Sep 15 2015 Orion Poplawski <orion@cora.nwra.com> - 6.0.4-6
- Rebuild for openmpi 1.10.0

* Sat Aug 15 2015 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 6.0.4-5
- Rebuild for MPI provides

* Sun Jul 26 2015 Sandro Mani <manisandro@gmail.com> - 6.0.4-4
- Rebuild for RPM MPI Requires Provides Change

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.0.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun May  3 2015 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 6.0.4-2
- Rebuild for changed mpich

* Sat Mar 14 2015 Sandro Mani <manisandro@gmail.com> - 6.0.4-1
- Update to 6.0.4

* Thu Mar 12 2015 Sandro Mani <manisandro@gmail.com> - 6.0.3-4
- Rebuild (mpich)

* Mon Dec 01 2014 Sandro Mani <manisandro@gmail.com> - 6.0.3-2
- Build esmumps

* Wed Nov 05 2014 Sandro Mani <manisandro@gmail.com> - 6.0.3-1
- Update to 6.0.3

* Mon Sep 22 2014 Sandro Mani <manisandro@gmail.com> - 6.0.1-1
- Update to 6.0.1

* Mon Aug 18 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.0.0-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Fri Aug 08 2014 Sandro Mani <manisandro@gmail.com> - 6.0.0-8
- Rework specfile

* Sat Jul 05 2014 Sandro Mani <manisandro@gmail.com> - 6.0.0-7
- Fix under-linked libraries (#1098680)

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.0.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Feb 27 2014 Deji Akingunola <dakingun@gmail.com> - 6.0.0-5
- Slightly modified Erik Zeek spec re-write (See 2012-10-08 below)
- Rename mpich and openmpi subpackages as ptscotch-(mpich/openmpi) (Laurence Mcglashan)

* Mon Feb 24 2014 Deji Akingunola <dakingun@gmail.com> - 6.0.0-4
- Rebuild for mpich-3.1

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sun Jul 21 2013 Deji Akingunola <dakingun@gmail.com> - 6.0.0-2
- Rename mpich2 sub-packages to mpich and rebuild for mpich-3.0

* Thu Jun 13 2013 Deji Akingunola <dakingun@gmail.com> - 6.0.0-1
- Update to 6.0.0
- Configured to run with 2 threads (for now)
- Install the headers in arch-dependent sub-directories

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.1.12-2.b
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sat Nov 17 2012 Deji Akingunola <dakingun@gmail.com> - 5.1.12-1.b
- Update to 5.1.12b

* Mon Oct 08 2012 Erik Zeek <eczeek@sandia.gov> - 5.1.11-4
- Use internal build machinery to build shared libraries.
- A bunch of MPI love.
-   Install Mpich2 libraries in the proper path.
-   Provide Mpich2 and OpenMPI libraries.

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.1.11-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.1.11-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Mar 29 2011 Deji Akingunola <dakingun@gmail.com> - 5.1.11-1
- Update to 5.1.11

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.1.10b-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Oct 19 2010 Deji Akingunola <dakingun@gmail.com> - 5.1.10b-1
- Update to 5.1.10b

* Thu Aug 12 2010 Deji Akingunola <dakingun@gmail.com> - 5.1.9-1
- Update to 5.1.9
- No more static builds

* Tue Apr 27 2010 Deji Akingunola <dakingun@gmail.com> - 5.1.8-1
- Update to 5.1.8

* Wed Nov 04 2009 Deji Akingunola <dakingun@gmail.com> - 5.1.7-2
- Fix the Source url

* Sun Sep 20 2009 Deji Akingunola <dakingun@gmail.com> - 5.1.7-1
- Update to 5.1.7
- Put the library under libdir

* Thu Jun 11 2009 Deji Akingunola <dakingun@gmail.com> - 5.1.6-3
- Further spec fixes from package review (convert license files to utf8)
- Prefix binaries and their corresponding manpages with scotch_ .
- Link in appropriates libraries when creating shared libs

* Thu Jun 04 2009 Deji Akingunola <dakingun@gmail.com> - 5.1.6-2
- Add zlib-devel as BR

* Wed May 13 2009 Deji Akingunola <dakingun@gmail.com> - 5.1.6-1
- Update to 5.1.6

* Fri Nov 21 2008 Deji Akingunola <dakingun@gmail.com> - 5.1.2-1
- Update to 5.1.2

* Fri Sep 19 2008 Deji Akingunola <dakingun@gmail.com> - 5.1.1-1
- initial package creation
